<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform"
    xmlns:xs="http://www.w3.org/2001/XMLSchema" exclude-result-prefixes="xs" version="2.0"
    xmlns:toc="http://www.oxygenxml.com/ns/webhelp/toc">

    <!-- Artifically impose content to the what's new topic. -->
    <xsl:template match="/">
        <xsl:next-match/>
        <xsl:result-document href="{resolve-uri('topics/what_s_new.dita', base-uri())}">
            <xsl:processing-instruction name="workdir-uri"><xsl:value-of select="replace(resolve-uri('topics/what_s_new.dita', base-uri()), 'what_s_new.dita', '')"/></xsl:processing-instruction>
            <xsl:processing-instruction name="path2project-uri">../</xsl:processing-instruction>
            <xsl:processing-instruction name="path2rootmap-uri">../</xsl:processing-instruction>
            <topic xmlns:ditaarch="http://dita.oasis-open.org/architecture/2005/"
                id="topic_v5l_lts_fsb" ditaarch:DITAArchVersion="1.3"
                domains="(topic abbrev-d)                            a(props deliveryTarget)                            (topic equation-d)                            (topic hazard-d)                            (topic hi-d)                            (topic indexing-d)                            (topic markup-d)                            (topic mathml-d)                            (topic pr-d)                            (topic relmgmt-d)                            (topic sw-d)                            (topic svg-d)                            (topic ui-d)                            (topic ut-d)                            (topic markup-d xml-d)   "
                class="- topic/topic ">
                <title class="- topic/title ">What's New!</title>
                <body class="- topic/body ">
                    <p class="- topic/p ">Most recent blog posts:</p>
                    <section class="- topic/section ">
                        <!-- Find the most recent topics by looking at the creation date and sorting them descending -->
                        <xsl:for-each
                            select="//topicref[@href][not(@format) or @format = 'dita'][doc-available(resolve-uri(@href, base-uri()))][document(resolve-uri(@href, base-uri()))/*/prolog/critdates/created/@date]">
                            <xsl:sort select="document(resolve-uri(@href, base-uri()))/*/prolog/critdates/created/@date" order="descending"/>
                            <!-- Present only the first 10 topics -->
                            <xsl:if test="position() &lt; 11">
                                <xsl:variable name="doc" select="document(resolve-uri(@href, base-uri()))"/>
                                <p class="- topic/p ">
                                    <xref href="{replace(@href, 'topics/', '')}" class="- topic/xref "><xsl:value-of select="$doc/*/title"/></xref>
                                    [Contributed by: <xref href="contributors.dita" class="- topic/xref "><xsl:value-of select="$doc/*/prolog/author"/></xref> on 
                                    <xsl:variable name="cd" select="$doc/*/prolog/critdates/created/@date"/>
                                    <xsl:value-of select="format-date(xs:date($cd), 
                                        '[D] [MNn,3-3] [Y0001]')"/>]
                                </p>
                            </xsl:if>
                        </xsl:for-each>
                    </section>
                </body>
            </topic>
        </xsl:result-document>
    </xsl:template>
</xsl:stylesheet>
